'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _ = require('../../');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var create = function create(template, pathCreate, name, req) {
  var forceJson = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : {};
  var duplicate = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : false;

  var p = new Promise(function (resolve, reject) {
    _.abeExtend.hooks.instance.trigger('beforeCreate', template, pathCreate, name, req, forceJson);

    var templatePath = _path2.default.join(_.config.root, _.config.templates.url, template + '.' + _.config.files.templates.extension);
    var filePath = _path2.default.join(pathCreate, name);
    filePath = _.coreUtils.slug.clean(filePath);
    filePath = _path2.default.join(_.config.root, _.config.draft.url, filePath.replace(_.config.root));
    if (templatePath !== null && filePath !== null) {
      var tplUrl = _.cmsData.file.fromUrl(filePath);

      if (!_.coreUtils.file.exist(tplUrl.json.path)) {
        var json = forceJson ? forceJson : {};
        var tpl = templatePath;
        var text = _.cmsTemplates.template.getTemplate(tpl);
        if (duplicate) {
          json = _.cmsData.values.removeDuplicate(text, json);
        }
        text = _.cmsData.source.removeDataList(text);
        var resHook = _.abeExtend.hooks.instance.trigger('beforeFirstSave', filePath, req.query, json, text);
        filePath = resHook.filePath;
        json = resHook.json;
        text = resHook.text;

        _.abeExtend.hooks.instance.trigger('afterCreate', json, text, pathCreate, name, req, forceJson);
        _.cmsOperations.save.save(filePath, template, json, text, 'draft', null, 'draft').then(function (resSave) {
          _.Manager.instance.updatePostInList(resSave.jsonPath);
          filePath = resSave.htmlPath;
          tplUrl = _.cmsData.file.fromUrl(filePath);
          resolve(resSave.json);
        }).catch(function (e) {
          reject();
          console.error(e);
        });
      } else {
        json = _.cmsData.file.get(tplUrl.json.path);
        resolve(json, tplUrl.json.path);
      }
    } else {
      reject();
    }
  }).catch(function (e) {
    console.error(e);
  });

  return p;
};

exports.default = create;