'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.remove = remove;
exports.removeFile = removeFile;
exports.olderRevisionByType = olderRevisionByType;

var _fsExtra = require('fs-extra');

var _fsExtra2 = _interopRequireDefault(_fsExtra);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _ = require('../../');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function remove(filePath) {
  filePath = _.abeExtend.hooks.instance.trigger('beforeDeleteFile', filePath);

  var revisions = _.cmsData.revision.getVersions(filePath);

  Array.prototype.forEach.call(revisions, function (revision) {
    _.cmsOperations.remove.removeFile(revision.path, revision.htmlPath);
  });

  _.Manager.instance.removePostFromList(filePath);
}

function removeFile(file, json) {
  if (_.coreUtils.file.exist(file)) {
    _fsExtra2.default.removeSync(file);
  }

  if (_.coreUtils.file.exist(json)) {
    _fsExtra2.default.removeSync(json);
  }
}

function olderRevisionByType(filePath, type) {

  var folder = _path2.default.dirname(filePath);
  var file = _path2.default.basename(filePath);
  var extension = _path2.default.extname(filePath);

  var files = _.coreUtils.file.getFilesSync(folder, false, extension);
  Array.prototype.forEach.call(files, function (fileItem) {
    var fname = _.cmsData.fileAttr.delete(fileItem);
    var ftype = _.cmsData.fileAttr.get(fileItem).s;
    if (fname === file && ftype === type) {
      var fileDraft = fileItem.replace(/-abe-./, '-abe-d');
      _.cmsOperations.remove.removeFile(fileItem, _.coreUtils.file.changePath(fileItem, _.config.data.url).replace(extension, '.json'));
      _.cmsOperations.remove.removeFile(fileDraft, _.coreUtils.file.changePath(fileDraft, _.config.data.url).replace(extension, '.json'));
    }
  });
}